<?php
/*
-------------------------------------------------------------------------
NetEye Webinject Configtool for Wuerth Phoenix NetEye
Copyright (C) 2010 by WUERTHPHOENIX Srl.
author Patrick Zambelli <patrick.zambelli@wuerth-phoenix.com>

http://www.wuerth-phoenix.com
--------------------------------------------------------------------------

 LICENSE

 This file is part of WuerthPhoenix NetEye ConfigurationTool.

 The NetEye ConfigurationTool is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation version 3 of the License.

 NetEye ConfigurationTool is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You can get a copy of the GNU General Public License included to the Dashboard or
 at http://www.gnu.org/licenses/gpl-3.0.txt. Otherwise write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
*/
class editorForm {
	var $mainpage = "index.php";
	var $formWidth = "690"; //overwritten in header
	var $model;

	function editorForm (&$formWidth, &$webinjectModel){
		$this->formWidth = $formWidth;
		$this->model = $webinjectModel;
	}

	function showMainForm(&$message){
		?>
<div class="divMainForm"><? $this->drawMainPage($message); ?></div>
		<?
	}
	function showEditForm($confToEdit, &$xmlPath, &$message){

		echo "<div class=\"divMainForm\">";
		$arr_testcases = $this->model->parseTestCases_from_XMLConfiguration($xmlPath.$confToEdit);
		if (isset($arr_testcases)){

			$this->drawEditTestcaseDefinitionForm($arr_testcases, $message, $xmlPath.$confToEdit, $confToEdit);
		} else {

			$message.="Exception while loading parsing the XML configuration. Abort.";
			$this->drawMainPage($message);
		}
		echo "</div>";

	}

	/*
	 * run and show the debug page
	 */
	function showDebugConf($webinjectConf, $xmlPath, $webinjectTestrunPath, $webinjectExecPath, $message){

		//array of test results
		$testRunResultsArray = array();
		
		if ($this->model->verifyWebinjectplAvailable($xmlPath, $webinjectTestrunPath, $message)){

			if (!$this->model->verifyConfigXML($xmlPath, $webinjectTestrunPath, $message)) {

				$message.="Warning: It was not possible to update the global config.xml for the execution for the testrun.<br>";
			}
			$this->model->start_testcase_execution($testRunResultsArray, $webinjectExecPath, $webinjectTestrunPath, $webinjectConf, $message, $xmlPath);

		}

		$this->drawTestcaseDebugResults($testRunResultsArray, $message);
	}

	/*
	 * Main Form for Configuration File view
	 */
	function drawMainPage(&$message){

		?>
<!-- The title section -->
<table
	style="width: 800px">
	<tr>
		<td>
		<table align="left" style="margin-left: 20px; width:<?php  echo $this->formWidth;?>px">
			<tr>
				<td align="left" colspan="0"><?php 
				if (isset($message) && $message != ""){
					echo "<div class=\"title\" id=\"message_space\"><font> $message </font></div>";
				} else {
					echo "<div class=\"title\" id=\"message_space\"><font>&nbsp;</font></div>";
				}
				?></td>
			</tr>
		</table>

		</td>
	</tr>

	<!--  The main table with file list  -->
	<tr>
		<td>

		<form name="formWebinjectMainPage" id="formWebinjectMainPage" enctype="application/x-www-form-urlencoded" action="./index.php"
	method="post" style="margin-left: 30px; width: <? echo $this->formWidth; ?>px;">
		<table width="700">

			<tr bgcolor="#B7B8BF" height="26">
				<td align="center"><b>Configuration file name</b></td>
				<td align="center"><b>Description</b></td>
				<td align="center"><b>Action</b></td>
			</tr>
			<?
			$counter=0;
			foreach ($this->model->arr_xmlConfigFiles as $configFile) {

				if ($counter%2) {$col="#cddee9";} else { $col="#f5f5f5"; }
				$counter++;

				if (strstr($configFile, "config.xml")) $col="#D6D6D2";

				echo "<tr bgcolor=\"$col\" class=\"table_main\">";
				echo "<td width=\"250\"><input type=\"hidden\" id=\"config_file\">$configFile</td>";

				echo "<td>";
				if (!strstr($configFile, "config.xml")){

					echo "Web 2.0 Test";
				}else {

					echo "Global configuration";
				}
				echo "</td>";

				echo "<td width=\"160\">";

				//Special file restrictions
				if (!strstr($configFile, "config.xml")){

					echo "<a href=\"#\" onClick=\"showConfigurationEditFormAction('".$configFile."');\"><img class=\"icon_main_page\" src=\"../images/icon_edit.png\" alt=\"Edit\" title=\"Edit configuration\" border=\"0\"/></a>";
					echo "<a href=\"#\" onClick=\"showRawXMLConfigurationViewFormAction('".$configFile."');\"><img class=\"icon_main_page\" src=\"../images/xml_icon.png\" alt=\"View\" title=\"View configuration\" border=\"0\"/></a>";
					echo "<a href=\"#\" onClick=\"showConfigureInNagios('".$configFile."');\"><img class=\"icon_main_page\" src=\"../images/icon_nagios.png\" alt=\"View\" title=\"Show how to configure this testcase for Nagios\" border=\"0\"/></a>";
					echo "<a href=\"#\" onClick=\"showConfigurationDeleteFormAction('".$configFile."');\"><img class=\"icon_main_page\" src=\"../images/action_delete.png\" alt=\"Delete\" title=\"Delete\" border=\"0\" /></a>";

					echo "&nbsp; <a href=\"#\" onClick=\"runTestcaseDebugAction('".$configFile."');\"><img class=\"icon_main_page\" src=\"../images/run.png\" alt=\"Run Debug\" title=\"Run a Web 2.0 Test configuration\" border=\"0\"/></a>";
					//echo "&nbsp; <a href=\"./index.php?runconf=".$configFile."\"><img class=\"icon_main_page\" src=\"../includes/run.png\" alt=\"Run Debug\" title=\"Run a Web 2.0 Test configuration\" border=\"0\"/></a>";

				} else {

					echo "<a href=\"#\" onClick=\"showRawXMLConfigurationViewFormAction('".$configFile."');\"><img class=\"icon_main_page\" src=\"../images/xml_icon.png\" alt=\"View\" title=\"View configuration\" border=\"0\"/></a>";
					echo "<img class=\"icon_main_page\" src=\"../images/forbidden.png\" alt=\"Not deletable\" title=\"Not deletable\" border=\"0\"/>";
				}

				echo "</td>";
				echo "</tr>";
			}
			?>
		</table>
		</form>
		</td>
	</tr>

	<!-- The option buttons -->
	<tr>
		<td height="12"></td>
	</tr>
	<tr>
		<td align="right">
		<table align="right" style="width: 300px">
			<tr>
				<td><a href="#" onclick="showDefineNewTestcaseForm();"
					class="button"><span>&nbsp;<img class="ico_edit"
					src="../images/new_icon.png"> &nbsp; Define a new test case &nbsp;</span></a></td>
			</tr>
		</table>
		<td>
	
	</tr>
</table>


			<?php
	}

	/*
	 * Draw the new Testcase definition form
	 */
	function drawNewTestcaseDefinitionForm($xmlPath, $message){

		$configFile = $xmlPath.'config.xml';

		//read XML config files
		if (!$this->model->testXMLWritability($configFile)){

			$message .= "WARNING: The File $configFile is not writable. <br> Therefore new testcases have to be registered manually inside config.xml.<br>";
		} else { $message .= "<br>"; }

		echo "<table style=\"width: 800px\"><tr><td>";

		//Print the message title
		echo "<table align=\"left\" style=\"margin-left: 20px; width: ".$this->formWidth."px\"><tr><td align=\"left\" colspan=\"0\">";
		if (isset($message) && $message != ""){
			echo "<div class=\"title\"><font class=\"message\"> $message </font></div>";
		} else { echo "<div class=\"title\"><font><br>&nbsp;</font></div>";	}
		echo "</td></tr></table>";

		echo "</td></tr><tr><td>";

		//The configuration definition form
		?>
<form name="createNewXML" id="createNewXML"	enctype="application/x-www-form-urlencoded" action="./index.php" method="post" style="margin-left: 30px; width: <? echo $this->formWidth; ?>px;">
<table align="left" width="700px" cellpadding="2" cellspacing="2">
	<tr>
		<td height="4" colspan="2"></td>
	</tr>
	<tr>
		<td align="left" colspan="2">
		<h2>Define form for new Webinject testcase file for Web 2.0
		monitoring.</h2>
		</td>
	</tr>
	<tr>
		<td height="4" colspan="2">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="1" align="right" style="width: 200px;">Define name for
		new <br>
		Testsession (filename):</td>
		<td colspan="1" align="left"><input type="text" name="testcase_name"
			id="testcase_name" class="editor_testcase_txt_normal"
			style="padding: 3px;"></td>
		<td>
		<div
			onMouseover="ddrivetip('The file name of the testcase(s) to create.<br><br>This name will be used for the configuration file followed by xml extension. (<name>.xml).', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>

	<tr>
		<td colspan="1" align="right" style="width: 200px;">Case ID (sequence
		number):</td>
		<td colspan="1" align="left"><input type="hidden" name="testcase_id"
			id="testcase_id" value="1">1</td>
		<td>
		<div
			onMouseover="ddrivetip('The ID sequence number of the test case.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>

	<tr>
		<td style="width: 200px;" colspan="1" align="right">Testcase
		Description:</td>
		<td align="left"><input type="text" name="testcase_desc"
			id="testcase_desc" class="editor_testcase_txt_normal" maxlength="130">
		</td>
		<td>
		<div
			onMouseover="ddrivetip('Description on the specific testcase.<br><br>This string is not interpreted and can therefore contain descriptive text.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">URL to open:</td>
		<td align="left"><input type="text" name="testcase_url"
			id="testcase_url" class="editor_testcase_txt_wide" maxlength="1024"
			value="http://"></td>
		<td>
		<div
			onMouseover="ddrivetip('Digit here to complete Web URL to open.<br><br>If the web server accepts for this URL arguments via GET, those values can be added as in any browser request like: http://www.url.com?argument=value&argument2=value2.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Method:</td>
		<td align="left"><select name="testcase_method" id="testcase_method"
			style="padding: 3px;" onchange="testcase_changemethod();">
			<option value="get">GET</option>
			<option value="post">POST</option>
		</select></td>
		<td>
		<div
			onMouseover="ddrivetip('Define whether the request is send optional arguments via GET or if a POST body is should be defined.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Postbody:</td>
		<td align="left"><input type="text" name="testcase_postbody"
			id="testcase_postbody" class="editor_testcase_txt_normal"
			maxlength="30" disabled="disabled"></td>
		<td>
		<div
			onMouseover="ddrivetip('Definition of the postbody content. <br>Example: postbody=username=corey&password=welcome', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Posttype:</td>
		<td align="left"><input type="text" name="testcase_posttype"
			id="testcase_posttype" class="editor_testcase_txt_normal"
			maxlength="30" value="application/x-www-form-urlencoded"></td>
		<td>
		<div
			onMouseover="ddrivetip('Definition of the HTML post type. <br>Example: application/x-www-form-urlencoded', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Verify string to
		be found in HTTP response:</td>
		<td align="left"><input type="text" name="testcase_verifypositive"
			id="testcase_verifypositive" class="editor_testcase_txt_normal"
			maxlength="50"></td>
		<td>
		<div
			onMouseover="ddrivetip('[OPTIONAL]: String to be parsed within the HTML reply from the server<br><br>This string has to appear anywhere in the HTML response string from the webserver to match this testcase successfully.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Verify string to
		NOT to be found in HTTP response:</td>
		<td align="left"><input type="text" name="testcase_verifynegative"
			id="testcase_verifynegative" class="editor_testcase_txt_normal"
			maxlength="50"></td>
		<td>
		<div
			onMouseover="ddrivetip('[OPTIONAL]: String to NOT to be found during the parse of the HTML reply from the server<br><br>This string must not appear anywhere in the HTML response string from the webserver to match this testcase successfully.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Parse HTTP
		response string:</td>
		<td align="left"><input type="text" name="testcase_parseresponse"
			id="testcase_parseresponse" class="editor_testcase_txt_normal"
			maxlength="50"></td>
		<td>
		<div
			onMouseover="ddrivetip('[OPTIONAL]: Parse following the regular expression format >href=leftboundary|rightboundary< for determined appearances within the HTML reply contenten to make this testcase return reccessfully.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Time in seconds to
		wait after testcase:</td>
		<td align="left"><select name="testcase_sleep" id="testcase_sleep">
			<option value="0">0</option>
			<option value="1">1</option>
			<option value="2">2</option>
			<option value="3">3</option>
			<option value="4">4</option>
			<option value="5">5</option>
		</select></td>
		<td>
		<div
			onMouseover="ddrivetip('Time to rest after the execution of this testcase before proceeding with an eventual next case or before returning the result.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>

	<tr>
		<td height="13">&nbsp; <input type="hidden" name="testcase_logrequest"
			id="testcase_logrequest" value="no" /> <input type="hidden"
			name="testcase_logresponse" id="testcase_logresponse" value="no" /> <input
			type="hidden" name="xml_folder" id="xml_folder"
			value="<? echo $xmlPath; ?>" /></td>
	</tr>
	<tr>
		<td style="width: 200px; min-width: 180px" height="15" align="right"></td>
		<td><a href="#" class="button" onclick="showMainPage()"><span> Cancel
		</span></a> <a href="#" class="button"
			onclick="submitAndCreateTestcase();"><span> &nbsp;<img
			class="ico_edit" src="../images/save_icon.png"> &nbsp;Save new
		testconfiguration&nbsp;</span></a></td>
	</tr>
</table>
</form>
		<?
		echo "</td></tr></table>";
		return true;
	}

	/*
	 * Draw the Edit module of a Testcase definition
	 */
	function drawEditTestcaseDefinitionForm(&$arr_testcases, &$message, $fullFilePath, $fileName){

		echo "<table style=\"width: 800px\"><tr><td>";

		//Print the message title
		echo "<table align=\"left\" style=\"margin-left: 20px; width: ".$this->formWidth."px\"><tr><td align=\"left\" colspan=\"0\">";
		if (isset($message) && $message != ""){

			echo "<div class=\"title\"><font class=\"message\"> $message </font></div>";
		} else { echo "<div class=\"title\"><font>&nbsp;</font></div>";	}
			
		echo "</td></tr></table>";

		echo "</td></tr><tr><td>";

		//The configuration definition form
		?>
<form name="editTestCaseForm" id="editTestCaseForm"	enctype="application/x-www-form-urlencoded" action="./action.webinjectConf.php" method="post" style="margin-left: 30px; width: <? echo $this->formWidth; ?>px;">
<table align="left" width="700px" cellpadding="2" cellspacing="2">
	<tr>
		<td height="4" colspan="2"></td>
	</tr>
	<tr>
		<td align="left" colspan="2">
		<h2>Edit form for Webinject testcase: <?php echo $fileName;?></h2>
		</td>
	</tr>

	<?php

	//iterate trough all testcases and show them in the form
	$i=0;
	foreach ($arr_testcases as $arr_testcase){
		?>
	<tr>
		<td height="4" colspan="2">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="3"><a href="#" class="button"
			onclick="removeTestcaseFromConfigFile('<?php echo $i+1;?>', '<?php echo $fileName;?>')"><span><img
			class="ico_edit" src="../images/close_icon.png"> Remove case ID <?php echo $i+1;?>
		</span></a></td>
	</tr>
	<tr>
		<td colspan="1" align="right" style="width: 200px;">Case ID (sequence
		number):</td>
		<td colspan="1" align="left"><input type="hidden"
			name="testcase_id_<?php echo $i;?>" id="testcase_id_<?php echo $i;?>"
			maxlength="20" size="40" style="padding: 3px;"
			value="<?php echo $arr_testcase['id'];?>"><?php echo $arr_testcase['id'];?>
		</td>
		<td>
		<div
			onMouseover="ddrivetip('The ID sequence number of the test case.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Testcase
		Description:</td>
		<td align="left"><input type="text"
			name="testcase_desc_<?php echo $i;?>"
			id="testcase_desc_<?php echo $i;?>"
			class="editor_testcase_txt_normal" maxlength="130"
			value="<?php echo $arr_testcase['description'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('Description on the specific testcase.<br><br>This string is not interpreted and can therefore contain descriptive text.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">URL to open:</td>
		<td align="left"><input type="text"
			name="testcase_url_<?php echo $i;?>"
			id="testcase_url_<?php echo $i;?>" class="editor_testcase_txt_wide"
			maxlength="1024" value="<?php echo $arr_testcase['url'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('Digit here to complete Web URL to open.<br><br>If the web server accepts for this URL arguments via GET, those values can be added as in any browser request like: http://www.url.com?argument=value&argument2=value2.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Method:</td>
		<td align="left"><select name="testcase_method_<?php echo $i;?>"
			id="testcase_method_<?php echo $i;?>" style="padding: 3px;"
			onchange="testcase_changemethod('<?php echo $i;?>');">
			<option value="get">GET</option>
			<?php
			if (stristr($arr_testcase['method'], "post")){
					
				echo "<option value=\"post\" selected=\"selected\">POST</option>";
			} else {
					
				echo "<option value=\"post\">POST</option>";
			}
			?>

		</select></td>
		<td>
		<div
			onMouseover="ddrivetip('Define whether the request is send optional arguments via GET or if a POST body is should be defined.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Postbody:</td>
		<td align="left"><input type="text"
			name="testcase_postbody_<?php echo $i;?>"
			id="testcase_postbody_<?php echo $i;?>"
			class="editor_testcase_txt_normal" maxlength="1024"
			<?php if (!stristr($arr_testcase['method'], "post")) echo "disabled=\"disabled\"";?>
			value="<?php echo $arr_testcase['postbody'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('Definition of the postbody content. <br>Example: postbody=username=corey&password=welcome', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Posttype:</td>
		<td align="left"><input type="text"
			name="testcase_posttype_<?php echo $i;?>"
			id="testcase_posttype_<?php echo $i;?>"
			class="editor_testcase_txt_normal" maxlength="130"
			value="<?php echo $arr_testcase['posttype'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('Definition of the HTML post type. <br>Example: application/x-www-form-urlencoded', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Verify string to
		be found in HTTP response:</td>
		<td align="left"><input type="text"
			name="testcase_verifypositive_<?php echo $i;?>"
			id="testcase_verifypositive_<?php echo $i;?>"
			class="editor_testcase_txt_normal" maxlength="150"
			value="<?php echo $arr_testcase['verifypositive'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('[OPTIONAL]: String to be parsed within the HTML reply from the server<br><br>This string has to appear anywhere in the HTML response string from the webserver to match this testcase successfully.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Verify string to
		NOT to be found in HTTP response:</td>
		<td align="left"><input type="text"
			name="testcase_verifynegative_<?php echo $i;?>"
			id="testcase_verifynegative_<?php echo $i;?>"
			class="editor_testcase_txt_normal" maxlength="150"
			value="<?php echo $arr_testcase['verifynegative'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('[OPTIONAL]: String to NOT to be found during the parse of the HTML reply from the server<br><br>This string must not appear anywhere in the HTML response string from the webserver to match this testcase successfully.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Parse HTTP
		response string:</td>
		<td align="left"><input type="text"
			name="testcase_parseresponse_<?php echo $i;?>"
			id="testcase_parseresponse_<?php echo $i;?>"
			class="editor_testcase_txt_normal" maxlength="150"
			value="<?php echo $arr_testcase['parseresponse'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('[OPTIONAL]: Parse following the regular expression format >href=leftboundary|rightboundary< for determined appearances within the HTML reply contenten to make this testcase return reccessfully.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;" colspan="1" align="right">Time in seconds to
		wait after testcase:</td>
		<td align="left"><select name="testcase_sleep_<?php echo $i;?>"
			id="testcase_sleep_<?php echo $i;?>">
			<?php
			for ($l=1;$l<6;$l++){
				if ($arr_testcase['sleep'] == $l){

					echo "<option value=\"$l\" selected=\"selected\">$l</option>";
				}else{
					echo "<option value=\"$l\">$l</option>";
				}
			}
			?>
		</select> <input type="hidden"
			name="testcase_logrequest_<?php echo $i;?>"
			id="testcase_logrequest_<?php echo $i;?>"
			value="<?php echo $arr_testcase['logrequest'];?>"> <input
			type="hidden" name="testcase_logresponse_<?php echo $i;?>"
			id="testcase_logresponse_<?php echo $i;?>"
			value="<?php echo $arr_testcase['logresponse'];?>"></td>
		<td>
		<div
			onMouseover="ddrivetip('Time to rest after the execution of this testcase before proceeding with an eventual next case or before returning the result.', 250)"
			; onMouseout="hideddrivetip()"><img src="./images/infoToolTip.png"
			width="30"></div>
		</td>
	</tr>
	<tr>
		<td colspan="3" align="right" valign="middle"><a href="#"
			class="button"
			onclick="insertTestcaseToConfigFile('<?php echo $i+2;?>', '<?php echo $fileName;?>')"><span><img
			class="ico_edit" src="../images/add_icon.png"> Insert a case at ID <?php echo $i+2;?>
		</span></a></td>
	</tr>
	<tr>
		<td colspan="3" valign="middle">
		<hr width="100%" size="1" color="#757FAB">
		</td>
	</tr>

	<?php
	$i++;
	}

	//Show the add button if absolutely no testcase exists
	if (count($arr_testcases) < 1){
		?>
	<tr>
		<td colspan="2" align="right"><a href="#" class="button"
			onclick="insertTestcaseToConfigFile('<?php echo $i+2;?>', '<?php echo $fileName;?>')"><span><img
			class="ico_edit" src="../images/add_icon.png"> Define a new testcase
		</span></a></td>
	</tr>
	<?php
	}
	?>

	<tr>
		<td height="13">&nbsp; <input type="hidden" name="xml_fullPath_file"
			id="xml_fullPath_file" value="<? echo $fullFilePath; ?>"> <input
			type="hidden" name="num_of_testcases" id="num_of_testcases"
			value="<? echo $i;?>"> <input type="hidden" name="testcase_name"
			id="testcase_name" value="<?php echo $fileName;?>"> <input
			type="hidden" name="action" id="action" value="submitUpdatedTestcase">
		</td>
	</tr>
	<tr>
		<td style="width: 20px; min-width: 180px"></td>
		<td align="right" colspan="2">
		<table style="width: 600px;">
			<tr>
				<td><a href="#" class="button"
					onclick="submitUpdatedTestcaseDone();"><span> &nbsp;<img
					class="ico_edit" src="../images/save_icon.png"> &nbsp; Submit
				configuration&nbsp; &nbsp; </span></a></td>
				<td><a href="#" class="button" onclick="showMainPage()"><span>
				Cancel & Back to Main view </span></a></td>
				<td><a href="#" class="button" onclick="submitUpdatedTestcase();"><span>
				&nbsp; &nbsp; Apply &nbsp; &nbsp; </span></a></td>
			</tr>
		</table>
		</td>
	</tr>
</table>
</form>
	<?
	echo "</td></tr></table>";
	return true;
	}


	/*
	 * Draw Testcase Debug results
	 */
	/*
	 * Draw the section of the webinject test run restults
	 */
	function drawTestcaseDebugResults (&$testRunResultsArray, &$message){

		?>
<!-- The title section -->
<table style="width: 800px">
	<tr>
		<td>
		<table align="left" style="margin-left: 20px; width:<?php  echo $this->formWidth;?>px">
			<tr>
				<td align="left" colspan="0"><?php 
				if (isset($message) && $message != ""){
					echo "<div class=\"title\"><font> $message </font></div>";
				} else {
					echo "<div class=\"title\"><font>&nbsp;</font></div>";
				}
				?></td>
			</tr>
		</table>

		</td>
	</tr>

	<tr>
		<td>
		<table align="left" width="760px" cellpadding="2" cellspacing="4">
		<?php
		//Results debug of results.html
		if (isset($testRunResultsArray[2])){ ?>
			<tr>
				<td>
				<div class="menu_table">
				<table cellpadding="0" cellspacing="0" width="700">
					<tr valign="top">
						<td align="left" width="50"><input type="image"
							src="../images/arrow_up.png" width="22px"
							class="buttonTestResultsUp"> <input type="image"
							src="../images/arrow_down.png" width="22px"
							class="buttonTestResultsDown"></td>
						<td align="left" colspan="2" valign="top"><font size="3"
							style="font-family: sans-serif; font-style: italic; vertical-align: middle; margin-left: 20px;"
							color="#175B8C"><b>Webinject testrun results:</b></font></td>
					</tr>
				</table>
				</div>
			
			</tr>
			<tr>
				<td>
				<div class="testResultsHTML">
					<a href="index.php" class="button" onclick=""><span> Back </span></a><br/>
					<? echo $testRunResultsArray[2]; ?></div>
				</td>
			</tr>


			<? }
			?>
			<tr>
				<td>
				<div class="menu_table"><font size="3"
					style="font-family: sans-serif; font-style: italic; vertical-align: middle; margin-left: 20px;"
					color="#175B8C"><b>Advanced debugging options:</b></font></div>
				</td>
			</tr>
			<tr>
				<td height="12"></td>
			</tr>

			<!--  The option buttons -->
			<tr height="20" valign="bottom">
				<td>
				<table cellpadding="0" cellspacing="0" width="700">
					<tr valign="top">
						<td align="left" width="200"><a href="#html_debug_view"
							name="modal" class="button" onclick=""><span> HTML code debug </span></a></td>
						<td align="left" width="200"><a href="#test_text_summary"
							name="modal" class="button" onclick=""><span> Text summary </span></a></td>
						<td align="left" width="150"><a href="index.php" class="button"
							onclick=""><span> Back </span></a></td>
						<td width="200"></td>
					</tr>
				</table>
				</td>
			</tr>
			
		<?php
		//Results view: HTML code debug
		if (isset($testRunResultsArray[2])){ ?>
			<tr>
				<td>
				<div class="menu_table">
				<table cellpadding="0" cellspacing="0" width="700">
					<tr valign="top">
						<td align="left" width="50"><input type="image"
							src="../images/arrow_up.png" width="22px"
							class="buttonHTMLDebugUp"> <input type="image"
							src="../images/arrow_down.png" width="22px"
							class="buttonHTMLDebugDown"></td>
						<td align="left" colspan="2" valign="top"><font size="3"
							style="font-family: sans-serif; font-style: italic; vertical-align: middle; margin-left: 20px;"
							color="#175B8C"><b>Testrun HTML code debug:</b></font></td>
					</tr>
				</table>
				</div>
			
			</tr>
			<tr>
				<td>
				<div class="testHTMLDebug">
					<table>
					<tr>
						<td><a href="index.php" class="button" onclick=""><span> Back </span></a>
						</td>
					</tr>
					<tr>
						<td><font class="font_ajax_subtitle">The content of the received HTML: </font><textarea id="testcase_results2"
						name="testcase_results2" title="Testcase result" rows="50" cols="125"><? echo str_ireplace("textarea", "textarea_repl", $testRunResultsArray[1]); ?>
						</textarea></td>
					</tr>
					</table>
				</div>
				</td>
			</tr>
			<? }
			?>

		</table>
		</td>
	</tr>
</table>


<!--  AJAX section -->
<div style="font-size: 10px; color: #ccc">Except where otherwise noted,
content on this site is licensed under a Creative Commons Attribution
3.0 License.</div>
<div id="boxes">

<!-- THE HTML CODE DEBUG VIEW START -->
<div id="html_debug_view" class="window">
<table class="dialog_title">
	<tr>
		<td><font class="font_ajax_title">HTML log view | <a href="#" class="close" />
		>>> Close <<< </a></font></td>
	</tr>
	<tr>
		<td><font class="font_ajax_subtitle">The content of the received HTML: </font><textarea id="testcase_results2"
			name="testcase_results2" title="Testcase result" rows="40" cols="100"><? echo str_ireplace("textarea", "textarea_repl", $testRunResultsArray[1]); ?>
			</textarea></td>
	</tr>
	<tr>
		<td align="center"><a href="#" class="button"
			onclick="close_modalFrame()"><span> Close </span></a></td>
	</tr>
</table>
</div>
<!-- THE HTML CODE DEBUG VIEW END -->

<!-- THE SUMMARY VIEW START -->
<div id="test_text_summary" class="window">
<table class="dialog_title">
	<tr>
		<td><font class="font_ajax_title"> The summary log of the testrun  | <a href="#" class="close" />
		>>> Close <<< </a></font></td>
	</tr>
	<tr>
		<td><textarea id="testcase_results2"
			name="testcase_results2" title="Testcase result" rows="40" cols="95"><? echo $testRunResultsArray[0]; ?>
			</textarea></td>
	</tr>
	<tr>
		<td align="center"><a href="#" class="button"
			onclick="close_modalFrame()"><span> Close </span></a></td>
	</tr>
</table>
</div>
<!-- THE SUMMARY VIEW START -->


<!-- Mask to cover the whole screen -->
<div id="mask"></div>
</div>
			<?php

	}

	/*
	 *
	 */
	function showdetatchedHTTPLogView($testRunResultsStr){

		?>
<table>
	<tr>
		<td align="left" colspan="2">
		<div class="menu_table"><font size="3"
			style="font-family: sans-serif; font-style: italic; vertical-align: middle; margin-left: 20px;"
			color="#175B8C"><b>HTML results WEB view (http.log)</b></font></div>
		</td>
		<td><a href="index.php" class="button" onclick=""><span> Back </span></a></td>
	</tr>
	<tr>
		<td>
		<div class="testResultsXML"><? echo $testRunResultsStr; ?></div>
		</td>
	</tr>
	<tr>
		<td height="8" colspan="2">
		<hr>
		</td>
	</tr>
</table>
		<?php

	}

	/*
	 * Draw the simple XML file viewer
	 */
	function drawRawXMLConfiguration($fileToEdit, $xmlPath, &$message){

		echo "<table style=\"width: 800px\"><tr><td>";

		//The message title
		echo "<table align=\"left\" style=\"margin-left: 20px; width: ".$this->formWidth."px\"><tr><td align=\"left\" colspan=\"0\">";
		if (isset($message) && $message != ""){
			echo "<div class=\"title\"><font> $message </font></div>";
		} else {
			echo "<div class=\"title\"><font>&nbsp;</font></div>";
		}
		echo "</td></tr></table>";

		echo "</td></tr><tr><td>";

		//The view form
		?>

<table align="left" style="margin-left: 20px; width: 700px">
	<tr>
		<td align="left" colspan="2">
		<h2>Simple view of Webinject XML Configuration: <? echo $fileToEdit; ?></h2>
		<br />
		<?
		if ($fileToEdit != "") {

			if (!$this->model->testXMLWritability($xmlPath.$fileToEdit)){

				echo "<b>WARNING: This file has been opened read only! Please check write permissions.</b>";
			} else {
				$configWritePermission=1;
			}?> <textarea id="xml_configuration"
			title="Webinject xml configuration" name="xml_configuration"
			rows="25" cols="110" style="padding: 4px;"><? echo $this->model->readXMLFile($xmlPath.$fileToEdit); ?></textarea>
			<?  } else {
				echo "&nbsp;";
				echo "<textarea id=\"xml_configuration\" title=\"Webinject xml configuration\" name=\"xml_configuration\" rows=\"25\" cols=\"90\" style=\"padding: 4px;\"></textarea>";
			}?></td>
	</tr>
	<tr>
		<td height="13">&nbsp;</td>
	</tr>
	<tr>
		<td height="15" align="right"></td>
		<td><input type="hidden" id="xmlFile_to_save"
			value="<? echo $xmlPath.$fileToEdit; ?>"> <a href="#" class="button"
			onclick="showMainPage()"><span> Cancel </span></a> <a href="#"
			class="button"
			onclick="showRawXMLConfigurationViewFormAction('<?php echo $fileToEdit; ?>');"><span>
		Reset changes </span></a> <a href="#;" class="button"
			onclick="submitAndSaveWebInjectRawXML(<? echo $configWritePermission; ?>);"><span>&nbsp;
		<img class="ico_edit" src="../images/save_icon.png">&nbsp; Submit
		configuration &nbsp; &nbsp; </span></a></td>
	</tr>
</table>
			<?
			echo "</td></tr></table>";
			return true;
	}

	/*
	 * Draw confirm host remove view
	 */
	function drawRemoveWebinjectConfForm($configFile, $message){
		?>
<form name="filterSettingsForm" id="filterSettingsForm"
	enctype="application/x-www-form-urlencoded" action="configuration.php"
	method="post"><br>
		<?php

		if (isset($message) && $message != ""){
			echo "<div class=\"title\" id=\"title_filter\"><font>$message </font></div>";
		} else {
			echo "<div class=\"title\" id=\"title_filter\"><font>&nbsp;</font></div>";
		}
		?> <br>
<table width="500" style="margin: 10 px; margin-left: 30px;">
	<tr>
		<td width="180">Webinject Configuration name:</td>
		<td colspan="2"><b><?echo $configFile;?></b></td>
	</tr>
	<tr>
		<td height="15" colspan="3"></td>
	</tr>
	<tr>
		<td colspan="3" align="right" valign="bottom">
		<table align="right" width="500">
			<tr>
				<td width="100"></td>
				<td align="right" width="200"><a href="#"
					onclick="confirmConfigurationDeleteFormAction('<?echo $configFile;?>');"
					class="button"> <span> Remove Configuration </span></a></td>
				<td align="right" width="200"><a href="#" onclick="showMainPage();"
					class="button"> <span> Cancel </span></a></td>
			</tr>
		</table>
		</td>
	</tr>

</table>
</form>
		<?

	}


	/*
	 * Draw the suggestions for the nagios configuration for this testcase
	 */
	function drawNagiosConfigForm($configFile, &$message){

		echo "<table style=\"width: 800px\"><tr><td>";

		$configurationName = explode(".", $configFile);

		//Print the message title
		echo "<table align=\"left\" style=\"margin-left: 20px; width: ".$this->formWidth."px\"><tr><td align=\"left\" colspan=\"0\">";
		if (isset($message) && $message != ""){
			echo "<div class=\"title\"><font class=\"message\"> $message </font></div>";
		} else { echo "<div class=\"title\"><font><br>&nbsp;</font></div>";	}
		echo "</td></tr></table>";

		echo "</td></tr><tr><td>";

		//The configuration definition form
		?>
<table align="left" width="700px" cellpadding="2" cellspacing="2">
	<tr>
		<td height="4" colspan="2"></td>
	</tr>
	<tr>
		<td align="left" colspan="2">
		<h2>Information to integrate Webinject into Nagios</h2>
		<br />
		These featues are provided by the "Nagios configuration architect:
		Monarch", accessible from the above drop down box of this
		NetEyeConfiguration menu.</td>
	</tr>
	<tr>
		<td height="4" colspan="2">&nbsp;</td>
	</tr>

	<tr>
		<td><a href="#" class="button" onclick="showMainPage()"><span> Back to
		main menu </span></a></td>
	</tr>

	<tr>
		<td style="width: 200px; margin-left: 100px;" height="15" colspan="2">
		<h3>The Nagios command definition:</h3>
		</td>
		</td>
	</tr>
	<tr>
		<td style="width: 200px;"2"><img alt=""
			src="./images/monarch_webinject_command.png"></td>
	</tr>

	<tr>
		<td height="4" colspan="2">&nbsp;</td>
	</tr>

	<tr>
		<td style="width: 200px; margin-left: 100px;" height="15" colspan="2">
		<h3>The Nagios Service definition:</h3>
		</td>
		</td>
	</tr>
	<tr>
		<td style="width: 200px; margin-left: 100px;" colspan="2">- Define a
		service with a possible name: <b>WEBINJECT: <?php echo $configurationName[0];?></b><br />
		- Select the previously created Check Command "check_webinject".<br />
		- In the Service command line field is shown:
		"check_webinject!$ARG1$".<br />
		&nbsp;&nbsp; Modify this value to: <b>"check_webinject!<?php echo $configFile;?>"</b>.<br />
		- Configure this service for a host, probably on which this service is
		running. If a third party service you can configure this service as
		check on the NetEye server or your internet gateway. <br />
		</td>
	</tr>
	<tr>
		<td height="3" colspan="2">&nbsp;</td>
	</tr>
	<tr>
		<td style="width: 200px;"2"><img alt=""
			src="./images/monarch_webinject_service.png"></td>
	</tr>
	<tr>
		<td height="4" colspan="2">&nbsp;</td>
	</tr>

	<tr>
		<td><a href="#" class="button" onclick="showMainPage()"><span> Back to
		main menu </span></a></td>
	</tr>
</table>

		<?
		echo "</td></tr></table>";
		return true;
	}

}
?>
